CON
  _clkmode = xtal1 + pll16x     
  _xinfreq = 5_000_000

  BUFFER_2K         = $800
  BUFFER_16         = $10 

  
  CR                = $0D
  LF                = $0A
  NULL              = $00
  DHCP_OPTIONS      = $F0
  DHCP_END          = $FF
  HARDWARE_ADDR_LEN = $06
  MAGIC_COOKIE_LEN  = $04
  UPD_HEADER_LEN    = $08
  MAX_DHCP_OPTIONS  = $10
  DHCP_PACKET_LEN   = $156 '342
  
  SOCKETS           = 8
  
  #0, CLOSED, TCP, UDP, IPRAW, MACRAW, PPPOE

    
  SHT_CLK         = 19                   { TEMP/ RV sensor}
  SHT_DATA        = 20                   { TEMP/ RV sensor}

  Zero_Out = 0                  {valvue to reset historic reading}

  i2cSCL        = 28   
  EEPROMAddr    = %1010_0000

  {{ DHCP Packet Pointers }}
  DHCP_OP            = $00
  DHCP_HTYPE         = $01
  DHCP_HLEN          = $02
  DHCP_HOPS          = $03
  DHCP_XID           = $04
  DHCP_SEC           = $08
  DHCP_FLAGS         = $0A
  DHCP_CIADDR        = $0C  
  DHCP_YIADDR        = $10
  DHCP_SIADDR        = $14
  DHCP_GIADDR        = $18
  DHCP_CHADDR        = $1C
  DHCP_BOOTP         = $2C
  DHCP_MAGIC_COOKIE  = $EC
  DHCP_DHCP_OPTIONS  = $F0

  {{ DHCP Options Enum}}
  SUBNET_MASK         = 01
  ROUTER              = 03
  DOMAIN_NAME_SERVER  = 06
  HOST_NAME           = 12
  REQUEST_IP          = 50
  MESSAGE_TYPE        = 53
  DHCP_SERVER_IP      = 54
  PARAM_REQUEST       = 55
  
  

  {{ DHCP Message Types}}
  DHCP_DISCOVER       = 1       
  DHCP_OFFER          = 2       
  DHCP_REQUEST        = 3       
  DHCP_DECLINE        = 4       
  DHCP_ACK            = 5       
  DHCP_NAK            = 6       
  DHCP_RELEASE        = 7      
                 
    
VAR
  long  seed
  long stack1[128]

  byte templock,notactive

  byte  temp[32]                               {input temp }
  byte  lv[32]                                 {input lv }
  long tempC,tempC1,tempC2,tempC3              {global temp vars }
  long lv1,lv2,lv3                             {global lv vars }

  long tempmax,tempmin       {Historis Min /Max Temp Variabelen }
  long lvmax,lvmin ,eepromData          {Historis Min /Max LV Variabelen } 
DAT
  index byte  "HTTP/1.1 200 OK", CR, LF, {
}             "Content-Type: text/html", CR, LF, CR, LF, {
}             "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>", CR, LF, {
}             "<html  xmlns='http://www.w3.org/1999/xhtml'>" , CR, LF, {
}             "<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8' />", CR, LF, {

}             "<meta name='viewport' content='width=device-width, initial-scale=1, maximum-scale=1'>", CR, LF, { 
}             "<meta name='description' content='An ICE Control Production.' >", CR, LF, { 
}             "<title>PX-100D</title>", CR, LF, {

}             "<link rel='stylesheet' href='http://192.168.2.151/test/style.css' type='text/css' media='screen' />", CR, LF, { 
}             "<link rel='stylesheet' href='http://chrisvalleskey.com/wp-content/themes/unique/css/custom/graph-style.css' type='text/css' media='screen' />", CR, LF, {

}             "<script type='text/javascript' src='http://192.168.2.151/test/graph.js'></script>", CR, LF, {
}             "<script type='text/javascript'>" , CR, LF, {

}             "window.onload = function() {", CR, LF, {
}             "g_graph = new Graph({", CR, LF, {
}             "'id': 'firstgraph',", CR, LF, {
}             "'strokeStyle': '#819C58',", CR, LF, {      
}             "'fillStyle': 'rgba(64,128,0,0.25)',", CR, LF, {
}             "'call': function(){ return ( Math.floor(latestTemp())); }", CR, LF, {
}             "});", CR, LF, {

}             "g_graph2 = new Graph({", CR, LF, {
}             "'id': 'secondgraph',", CR, LF, {
}             "'strokeStyle': '#819C58',", CR, LF, {
}             "'fillStyle': 'rgba(64,128,0,0.25)',", CR, LF, {
}             "'call': function(){ return ( Math.floor(latestHumidity())); }", CR, LF, {
}             "});}", CR, LF, {

}             "</script>", CR, LF, {

}             "<script type='text/javascript'>", CR, LF, {
}             "setInterval(", $22, "getRequest('xmltemp', 'placeholder')", $22, ", 1000);", CR, LF, {



}             "</script>", CR, LF, {
}             "</head>", CR, LF, {

}             "<body id='graph' class='page'>", CR, LF, {
}             "<header id='top-bar' class='bar'>", CR, LF, { 
}             "<h1><a href='http://192.168.2.151'>ICE Control</a></h1>", CR, LF, {   
}             "</header>", CR, LF, {



}             "<article id='post' role='main'>", CR, LF, {
}             "<div class='container'>", CR, LF, {
}             "<header>", CR, LF, {
}             "<hgroup>", CR, LF, {
}             "<h1>Temperatuur</h1>", CR, LF, {    
}             "</hgroup>", CR, LF, {
}             "</header>", CR, LF, {  
}             "<section class=post-content'>", CR, LF, {  

}             "<body>", CR, LF, {
}             "<div><span id='placeholder'>10.0</span></div>", CR, LF, {
}             "<div><canvas id='firstgraph' width='940' height='200'></canvas><p class='buttons'>", CR, LF, {   
}             "<a onclick=", $22, "toggleValue('showgrid')", $22, "class='btn'>Grid</a>", CR, LF, {  
}             "<a onclick=", $22, "toggleValue('showshadow')", $22, "class='btn'>Shadow</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showline')", $22, "class='btn'>Lines</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showfill')", $22, "class='btn'>Fill</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showdots')", $22, "class='btn'>Dots</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showlabels')", $22, "class='btn'>Labels</a>", CR, LF, {

}             "<a onclick='setFill()' class='btn'>Random Fill</a>", CR, LF, {
}             "<a onclick='setColor()' class='btn'>Random Color</a>", CR, LF, {
}             "<a onclick='clearGraph()' class='btn right'>Clear Graph</a>", CR, LF, {
}             "<a onclick='toggleDraw()' class='btn right'>Toggle Draw</a> ", CR, LF, {    
}             "</p>", CR, LF, {

}             "</div>", CR, LF, {

}             "<script type='text/javascript'>" , CR, LF, { 
}             "function toggleDraw() { g_graph.toggleDraw(); }", CR, LF, {
}             "function toggleValue(value) { g_graph.toggleValue(value); }", CR, LF, {
}             "function setFill(val) { if(val == undefined) val = getRandomRGBA(); g_graph.setValue('fillStyle',val); }", CR, LF, {
}             "function setColor(val) { if(val == undefined) val = getRandomRGB(); g_graph.setValue('strokeStyle',val); }", CR, LF, {
}             "function getRandomRGB() { return 'rgb(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ')'; }", CR, LF, {
}             "function getRandomRGBA() { return 'rgba(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ', ' + '0.25)'; }", CR, LF, {
}             "function clearGraph() { g_graph.clearGraph(); }", CR, LF, {
}             "</script>", CR, LF, {  
}             "</header>", CR, LF, {
}             "</article>", CR, LF, {


}             "<article id='post' role='main'>", CR, LF, {
                                                               post
}             "<div class='container'>", CR, LF, {
}             "<header>", CR, LF, {
}             "<hgroup>", CR, LF, {
}             "<h1>Vochtigheid</h1>", CR, LF, {    
}             "</hgroup>", CR, LF, {                         
}             "</header>", CR, LF, {   
}             "<section class=post-content'>", CR, LF, {  



}             "<div><span id='placeholder2'>5.0</span></div>", CR, LF, { 
}             "<div><canvas id='secondgraph' width='940' height='200'></canvas><p class='buttons'>", CR, LF, {      

}             "<a onclick=", $22, "toggleValue('showgrid')", $22, "class='btn'>Grid</a>", CR, LF, {  
}             "<a onclick=", $22, "toggleValue('showshadow')", $22, "class='btn'>Shadow</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showline')", $22, "class='btn'>Lines</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showfill')", $22, "class='btn'>Fill</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showdots')", $22, "class='btn'>Dots</a>", CR, LF, {
}             "<a onclick=", $22, "toggleValue('showlabels')", $22, "class='btn'>Labels</a>", CR, LF, {

}             "<a onclick='setFill()' class='btn'>Random Fill</a>", CR, LF, {
}             "<a onclick='setColor()' class='btn'>Random Color</a>", CR, LF, {
}             "<a onclick='clearGraph()' class='btn right'>Clear Graph</a>", CR, LF, {
}             "<a onclick='toggleDraw()' class='btn right'>Toggle Draw</a> ", CR, LF, {    
}             "</p>", CR, LF, {

}             "</div>", CR, LF, {  

}             "<script type='text/javascript'>" , CR, LF, { 
}             "function toggleDraw() { g_graph2.toggleDraw(); }", CR, LF, {
}             "function toggleValue(value) { g_graph2.toggleValue(value); }", CR, LF, {
}             "function setFill(val) { if(val == undefined) val = getRandomRGBA(); g_graph2.setValue('fillStyle',val); }", CR, LF, {
}             "function setColor(val) { if(val == undefined) val = getRandomRGB(); g_graph2.setValue('strokeStyle',val); }", CR, LF, {
}             "function getRandomRGB() { return 'rgb(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ')'; }", CR, LF, {
}             "function getRandomRGBA() { return 'rgba(' + Math.floor(Math.random()*255)  + ', ' + Math.floor(Math.random()*255) + ', ' + Math.floor(Math.random()*255) + ', ' + '0.25)'; }", CR, LF, {
}             "function clearGraph() { g_graph2.clearGraph(); }", CR, LF, {
}             "</script>", CR, LF, {   

}             "</div>", CR, LF, {   
}             "<div>", CR, LF, {
}             "<a href='index.html'> kas </a>", CR, LF, {  
}             "<a href='halo'> Test </a>", CR, LF, {  
}             "</div>", CR, LF, {  


}             "</body>", CR, LF, {
}             "</html>", 0



  halo byte  "HTTP/1.1 200 OK", CR, LF, {
}             "Content-Type: text/html", CR, LF, CR, LF, {
}             "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>", CR, LF, {
}             "<html  xmlns='http://www.w3.org/1999/xhtml'>" , CR, LF, {
}             "<head><meta http-equiv='Content-Type' content='text/html; charset=utf-8' />", CR, LF, {
}             "<title>HALO</title>", CR, LF, {


}             "</head>", CR, LF, {
}             "<body>", CR, LF, {

}             "<div>", CR, LF, {
}             "<a href='index.html'> kas </a>", CR, LF, {  
}             "<a href='halo'> Test </a>", CR, LF, {
}             "</div>", CR, LF, {  


}             "</body>", CR, LF, {
}             "</html>", 0





  xml   byte  "HTTP/1.1 200 OK", CR, LF, {
  }           "Content-Type: text/xml", CR, LF, CR, LF, {
  }           "<?xml version='1.0' encoding='utf-8'?><root><temp>"
  temperature  byte  $30, $30, $2E, $30, "</temp><humidity>"
  lvlv     byte  $30, $30, $2E, $30, "</humidity></root>", 0
  
  buff  byte  $0[BUFFER_2K]
  resPtr long $0[25]

OBJ
  pst             : "Parallax Serial Terminal"
  wiz             : "W5200.spin" 
  sock[SOCKETS] : "Socket.spin"
  sht           : "Sensirion_full"         { temp/lv sensor control object }
  fp            : "FloatString"              { Math object }
  f             : "Float32"                  { Math object }
  i2cObject     : "basic_i2c_driver"         {Eprom object}  
PUB Main | i, page

  
  dira[8]~~
  outa[8]~~
  
  cognew(tempcontrol,@stack1)
  
  buffPtr := @buff

  pst.Start(115_200)
  pause(500)

  pst.str(string("Initialize", CR))
  CreateTransactionId

  'Wiz Mac and Ip
  wiz.Init
  wiz.SetIp(192, 168, 1, 1)
  wiz.SetMac($00, $08, $DC, $16, $F8, $01)
  
  'DHCP Port, Mac and Ip 
  sock.Init(0, UDP, 68)

  'Broadcast to port 67
  sock.RemoteIp(255, 255, 255, 255)
  sock.RemotePort(67)

  'DHCP Process
  Discover
  Offer
  Request
  if(Ack)
    pst.str(string("IP Assigned......."))
  else
    pst.str(string("DHCP Failed", CR))

  PrintIp(wiz.GetIp)

  pst.str(string("DNS..............."))
  PrintIp(wiz.GetDns)

  pst.str(string("DHCP Server......."))
  printIp(wiz.GetDhcpServerIp)

  pst.str(string("Router IP........."))
  printIp(wiz.GetRouter)
  pst.char(CR)

  sock.Close 
  
  repeat
    pst.str(string("Initialize Sockets",CR))
    repeat i from 0 to SOCKETS-1
      sock[i].Init(i, TCP, 8080)
           
    OpenListeners
    StartListners
        
    pst.str(string("Start Socket server",CR))
    \MultiSocketServer
    pst.str(string("I blew up!"))
    pause(5000)


  
PUB OpenListeners | i
  pst.str(string("Open",CR))
  repeat i from 0 to SOCKETS-1  
    sock[i].Open
      
PUB StartListners | i
  repeat i from 0 to SOCKETS-1
    if(sock[i].Listen)
      pst.str(string("Listen "))
    else
      pst.str(string("Listener failed ",CR))
    pst.dec(i)
    pst.char(CR)

PUB CloseWait | i
  repeat i from 0 to SOCKETS-1
   
    if(sock[i].IsCloseWait) 
      sock[i].Disconnect
      sock[i].Close
      
    if(sock[i].IsClosed)  
      sock[i].Open
      sock[i].Listen

PUB MultiSocketServer | bytesToRead, i, page, j, x , bytesSent, ptr
  bytesToRead := bytesSent := i := j := x := 0
  repeat
    pst.str(string("TCP Service", CR))
    CloseWait

    repeat j from 0 to SOCKETS-1
      pst.str(string("Socket "))
      pst.dec(j)
      pst.str(string(" = "))
      pst.hex(wiz.GetSocketStatus(j), 2)
      pst.char(13)
     
    repeat until sock[i].Connected
      i := ++i // SOCKETS

    pst.str(string("Connected Socket "))
    pst.dec(i)
    pst.char(CR)
    
    'Data in the buffer?
    repeat until bytesToRead := sock[i].Available

    'Check for a timeout
    if(bytesToRead < 0)
      pst.str(string("Timeout",CR))
      sock[i].Disconnect
      sock[i].Open
      sock[i].Listen
      bytesToRead~
      next

    pst.str(string("Copy Rx Data",CR))
  
    'Get the Rx buffer  
    sock[i].Receive(@buff, bytesToRead)

    {{ Process the Rx data}}
    pst.char(CR)
    pst.str(string("Request:",CR))
    'pst.str(@buff)

    pst.str(string("Send Response",CR))
    page :=  ParseResource(@buff)
    
    pst.str(page)
    pst.char(CR)
    pst.str(string("Byte to send "))
    pst.dec(strsize(page))
    pst.char(CR)

    bytesSent := 0
    ptr := page
    repeat until bytesSent == strsize(page)
      bytesSent += sock[i].Send(ptr, strsize(ptr))
      ptr := page + bytesSent

    pst.str(string("Bytes Sent "))
    pst.dec(bytesSent)
    pst.char(CR)

    pst.str(string("Disconnect socket "))
    pst.dec(i)
    pst.char(CR)

    if(sock[i].Disconnect)
      pst.str(string("Disconnected", CR))
    else
      pst.str(string("Force Close", CR))
    sock[i].Open
    sock[i].Listen
    sock[i].SetSocketIR($FF)
    
    i := ++i // SOCKETS
    bytesToRead~
    
{
PUB ParseResource(header) | ptr, value
  ptr := header
  repeat until byte[ptr++] == $2F '/ forward slash
  if(byte[ptr] == $20) ' space
    return @index
  else
    value := GetTemp
    SetTemp(tempc3)
    Setlv(lv3)
    return @xml
}

PUB ParseResource(header) | ptr, value, i, done, j
  ptr := header
  i := 0
  done := false

  repeat until IsEndOfLine(byte[ptr])
    if(IsToken(byte[ptr]))
      byte[ptr] := 0
      resPtr[i++] := ++ptr
    else
      ++ptr

    if(ptr - header > 500)
      pst.str(string(CR, "+++++++++++++++[ERROR]++++++++++++++",CR))
      return @index

  resPtr[0] := header
  repeat j from 0 to i-1
    pst.str(string("ID"))
    pst.dec(j)
    pst.char($20)
    pst.str(resPtr[j])
    pst.char(CR)

  repeat j from 0 to i-1
    if(strcomp(resPtr[j], string("HTTP")))
      return @index

    if(strcomp(resPtr[j], string("halo")))
      return @halo

      
    if(strcomp(resPtr[j], string("xmltemp")))
      value := GetTemp
      SetTemp(tempc3)
      Setlv(lv3)
      return @xml

  
PUB IsToken(value)
  return lookdown(value: "/", "?", "=", " ")

PUB IsEndOfLine(value)
  return lookdown(value: CR, LF)

PUB GetTemp
  seed := CNT 
  ?seed
  return seed & $0F + 1
  
PUB SetTemp(value) | t1
  t1 := value
  t1 := t1/100
  value -= t1 * 100
  if(t1 > 0 and t1 < 9)
    byte[@temperature][0] := t1 + $30
  else
    ResetTemp
    return 

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  if(t1 > 0 and t1 < 9) 
    byte[@temperature][1] := t1 + $30
  else
    ResetTemp
    return
    
  t1 := value
  if(t1 > 0 and t1 < 9)  
    byte[@temperature][3] := t1 + $30
  else
    ResetTemp
    return
    
PUB SetLV(value) | t1                                              
  t1 := value
 

  t1 := value
  t1 := t1/10
  value -= t1 * 10
  'if(t1 > 0 and t1 < 9) 
    byte[@lvlv][0] := t1 + $30
  'else
    'ResetTemp
    'return
    
  t1 := value
  'if(t1 > 0 and t1 < 9)  
    byte[@lvlv][1] := t1 + $30
  'else
    'ResetTemp
    'return
  
  
PUB ResetTemp
  byte[12] := $30
  byte[13] := $30
  byte[14] := $30  
     



     
PUB PrintIp(addr) | i
  repeat i from 0 to 3
    pst.dec(byte[addr][i])
    if(i < 3)
      pst.char($2E)
    else
      pst.char($0D)
  
PRI pause(Duration)  
  waitcnt(((clkfreq / 1_000 * Duration - 3932) #> 381) + cnt)
  return

PUB Tempcontrol

    
    templock:=locknew
  
    
    sht.start(SHT_DATA,SHT_CLK)
    f.start
    
    lvmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6997)
    lvmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6993)
    tempmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6989)
    tempmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6985)
    
  repeat 
    repeat until not lockset(templock)    
      sht.config(33,sht#off,sht#yes,sht#hires)
      tempC := celsius(f.FFloat(sht.readHumidity))
      tempC1 := F.FMul(celsius(f.FFloat(sht.readTemperature)),10.0)     {floating point raw measurement temp}
    
      bytemove(@Temp, tempC2, strsize(tempC2) +1)      { copy string }
      tempC3 :=f.FTrunc(tempC1)                              { integer to calculate/use  }
      
     
      lv1 := humidityy(tempC, f.FFloat(sht.readHumidity))   {floating poitn ram measurement RH }
      
      bytemove(@Lv, lv2, strsize(lv2) +1)            { copy string }
      lv3 :=f.FTrunc(lv1)
      lockclr(templock)
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''  

    if tempmin == 0                                    '' max/ min temp geheugen ''
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
           tempmin:=tempC3
                 
    if tempC3 > tempmax
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries" }
          tempmax := tempC3
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6989, tempC3)
           
    if tempC3 < tempmin
       if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
         tempmin := tempC3   
         i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6985, tempC3)

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    if lvmin == 0                                    '' max/ min lv geheugen ''
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries } 
           lvmin:=lv3
                 
    if lv3 > lvmax
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }
          lvmax := lv3                                 
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6997, lv3)
                     
    if lv3 < lvmin
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }  
          lvmin := lv3   
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6993, lv3) 
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''           
    waitcnt(clkfreq + cnt)

PUB celsius(t)
  ' from SHT1x/SHT7x datasheet using value for 3.5V supply
  ' celsius = -39.7 + (0.01 * t)
  return f.FAdd(-39.7, f.FMul(0.01, t))  
  
PUB humidityy(t, rhh) | rhLinear
  ' rhLinear = -2.0468 + (0.0367 * rh) + (-1.5955E-6 * rh * rh)
  ' simplifies to: rhLinear = ((-1.5955E-6 * rh) + 0.0367) * rh -2.0468
  rhLinear := f.FAdd(f.FMul(f.FAdd(0.0367, f.FMul(-1.5955E-6, rhh)), rhh), -2.0468)
  ' rhTrue = (t - 25.0) * (0.01 + 0.00008 * rawRH) + rhLinear
  return f.FAdd(f.FMul(f.FSub(t, 25.0), f.FAdd(0.01, f.FMul(0.00008, rhh))), rhLinear)

DAT
  magicCookie     byte  $63, $82, $53, $63
  paramReq        byte  $01, $03, $06, $2A ' Paramter Request; mask, router, domain name server, network time
  hostName        byte  "PropNet_5200", $0 
  workspace       byte  $0[BUFFER_16]  


  optionPtr       long  $F0
  buffPtr         long  $00
  transId         long  $00

PUB Discover | len
  'optionPtr is a global pointer used in the
  'WriteDhcpOption and ReadDhcpOption methods
  optionPtr := DHCP_OPTIONS + buffPtr
  
  FillOpHtypeHlenHops($01, $01, $06, $00)
  
  FillTransactionID
  FillMac
  FillMagicCookie
  WriteDhcpOption(MESSAGE_TYPE, 1, DHCP_DISCOVER)
  WriteDhcpOption(REQUEST_IP, 4, wiz.GetCommonRegister(wiz#SOURCE_IP0))
  WriteDhcpOption(PARAM_REQUEST, 4, @paramReq)
  WriteDhcpOption(HOST_NAME, strsize(@hostName), @hostName)
  len := EndDhcpOptions
  DisplayMemory(buffPtr, len, true)
  SendReceive(buffPtr, len)

  
PUB Offer | len
  optionPtr := DHCP_OPTIONS + buffPtr
  
  buffPtr += UPD_HEADER_LEN
  
  GetIp
  len := ReadDhcpOption(DOMAIN_NAME_SERVER)
  
  pst.dec(len)
  pst.char(13)
  Wiz.copyDns(optionPtr, len)
  
  GetGateway

  len := ReadDhcpOption(SUBNET_MASK)
  wiz.CopySubnet(optionPtr, len)

  len := ReadDhcpOption(ROUTER)
  wiz.CopyRouter(optionPtr, len)

  len := ReadDhcpOption(DHCP_SERVER_IP)
  wiz.CopyDhcpServer(optionPtr, len) 
  
  buffPtr -= UPD_HEADER_LEN

PUB Request | len
  optionPtr := DHCP_OPTIONS + buffPtr
  
  'Broadcast - There must be a bug if I have to decalre teh RemoteIP again?
  'Or maybe it is because the internal register updated - bet that's it!
  sock.RemoteIp(255, 255, 255, 255)

  
  bytefill(@buff, 0, BUFFER_2K)
  FillOpHtypeHlenHops($01, $01, $06, $00)
  FillTransactionID
  FillMac
  FillServerIp
  FillMagicCookie
  WriteDhcpOption(MESSAGE_TYPE, 1, DHCP_REQUEST)
  WriteDhcpOption(REQUEST_IP, 4, wiz.GetCommonRegister(wiz#SOURCE_IP0))
  WriteDhcpOption(DHCP_SERVER_IP, 4, wiz.GetDhcpServerIp)
  WriteDhcpOption(HOST_NAME, strsize(@hostName), @hostName)
  len := EndDhcpOptions
  DisplayMemory(buffPtr, len, true)
  SendReceive(buffPtr, len)

PUB Ack | len
  optionPtr := DHCP_OPTIONS + buffPtr
  
  buffPtr += UPD_HEADER_LEN
  len := ReadDhcpOption(MESSAGE_TYPE)
  buffPtr -= UPD_HEADER_LEN
  return byte[optionPtr] == DHCP_ACK   

PUB GetIp | ptr
  ptr := @byte[buffPtr][DHCP_YIADDR]
  PrintIP(ptr)
  Wiz.SetIp(byte[ptr][0], byte[ptr][1], byte[ptr][2], byte[ptr][3])
  

PUB GetGateway | ptr
  ptr := @byte[buffPtr][DHCP_SIADDR]
  PrintIP(ptr)
  Wiz.SetGateway(byte[ptr][0], byte[ptr][1], byte[ptr][2], byte[ptr][3])


PUB FillOpHTypeHlenHops(op, htype, hlen, hops)
  byte[buffPtr][DHCP_OP] := op
  byte[buffPtr][DHCP_HTYPE] := htype
  byte[buffPtr][DHCP_HLEN] := hlen
  byte[buffPtr][DHCP_HOPS] := hops  


PUB CreateTransactionId
  transId := CNT
  ?transId
  
PUB FillTransactionID
  long[buffPtr+DHCP_XID] := transId

PUB FillMac
  bytemove(buffPtr+DHCP_CHADDR, wiz.GetCommonRegister(wiz#MAC0), HARDWARE_ADDR_LEN)    

PUB FillServerIp
  bytemove(buffPtr+DHCP_SIADDR, wiz.GetDhcpServerIp, 4)

  
PUB FillMagicCookie
  bytemove(buffPtr+DHCP_MAGIC_COOKIE, @magicCookie, MAGIC_COOKIE_LEN)


PUB WriteDhcpOption(option, len, data)
  byte[optionPtr++] := option
  byte[optionPtr++] := len
  
  if(len == 1)
    byte[optionPtr] := data
  else
    bytemove(optionPtr, data, len)
    
  optionPtr += len

PUB ReadDhcpOption(option) | len
  'Init pointer to options
  optionPtr := DHCP_OPTIONS + buffPtr

  'Repeat until we reach the end of the UPD packet
  repeat MAX_DHCP_OPTIONS

    if(byte[optionPtr] == DHCP_END)
      return -2
  
    if(byte[optionPtr++] == option)
      'return len and set the pointer to the data (hub) address
      return byte[optionPtr++]

    'point to the next option code 
    optionPtr += byte[optionPtr] + 1

  return -1 
      
  
PUB EndDhcpOptions | len
  byte[optionPtr] := DHCP_END
  return DHCP_PACKET_LEN
  'return ((optionPtr-buffPtr) // 16) + (optionPtr-buffPtr) + 1
 

PUB SendReceive(buffer, len) | receiving, bytesToRead, ptr 
  
  bytesToRead := 0

  pst.str(string("Send Bytes: "))
  pst.dec(len)             
  pst.char(CR)
  
  pst.str(string("Open",CR))
  sock.Open
  
  pst.str(string("Send Message",CR))
  
  sock.Send(buffer, len)

  receiving := true
  repeat while receiving 
    'Data in the buffer?
    bytesToRead := sock.Available
    pst.str(string("Bytes to Read: "))
    pst.dec(bytesToRead)
    pst.char(13)
    pst.char(13)
     
    'Check for a timeout
    if(bytesToRead == -1)
      receiving := false
      pst.str(string("Fail safe", CR))
      next

    if(bytesToRead == 0)
      receiving := false
      pst.str(string("Done", CR))
      next 

    if(bytesToRead > 0) 
      'Get the Rx buffer  
      ptr := sock.Receive(buffer, bytesToRead)
      pst.char(CR)
      pst.str(string("UPD Header:",CR))
      PrintIp(buffer)
      pst.dec(DeserializeWord(buffer + 4))
      pst.char(CR)
      pst.dec(DeserializeWord(buffer + 6))
      pst.char(CR)
       
      pst.char(CR) 
      DisplayMemory(ptr, DeserializeWord(buffer + 6), true) 
      pst.char(CR)
      
    bytesToRead~

  pst.str(string(CR, "Disconnect", CR)) 
  sock.Disconnect


PUB DisplayMemory(addr, len, isHex) | j
  pst.str(string(13,"-----------------------------------------------------",13))
  pst.str(string(13, "      "))
  repeat j from 0 to $F
    pst.hex(j, 2)
    pst.char($20)
  pst.str(string(13, "      ")) 
  repeat j from 0 to $F
    pst.str(string("-- "))

  pst.char(13) 
  repeat j from 0 to len
    if(j == 0)
      pst.hex(0, 4)
      pst.char($20)
      pst.char($20)
      
    if(isHex)
      pst.hex(byte[addr + j], 2)
    else
      pst.char($20)
      if(byte[addr+j] == 0)
        pst.char($20)
      pst.char(byte[addr+j])

    pst.char($20) 
    if((j+1) // $10 == 0) 
      pst.char($0D)
      pst.hex(j+1, 4)
      pst.char($20)
      pst.char($20)  
  pst.char(13)
  
  pst.char(13)
  pst.str(string("Start: "))
  pst.dec(addr)
  pst.str(string(" Len: "))
  pst.dec(len)
  pst.str(string(13,"-----------------------------------------------------",13,13))
      

      
PRI SerializeWord(value, buffer)
  byte[buffer++] := (value & $FF00) >> 8
  byte[buffer] := value & $FF

PRI DeserializeWord(buffer) | value
  value := byte[buffer++] << 8
  value += byte[buffer]
  return value
        