CON

  _clkmode = xtal1 + pll16x
 _xinfreq = 5_000_000


SR_CLOCK        = 0                    { lcd driver }
SR_LATCH        = 1                    { lcd driver }
SR_DATA         = 2                    { lcd driver }

Led_1           = 9                    { Temp Led }
Led_2           = 10                    { LV Led }
Led_3           = 11                   { CO2 Led }
Led_4           = 12                   { Histories Max Led }
Led_5           = 13                   { Histories Min Led }
Led_6           = 14                   { Setpoint Day }
Led_7           = 15                   {Setpoint Night }

ADC_3           = 18                   {ADC control }
ADC_2           = 17                   {ADC control }
ADC_1           = 16                   {ADC control }

SHT_CLK         = 19                   { TEMP/ RV sensor}
SHT_DATA        = 20                   { TEMP/ RV sensor}

Relay_3         = 21                   {SSR Control}
Relay_2         = 22                   {SSR Control}
Relay_1         = 23                   {SSR Control}

buton1          = 24                   { push buttons }
buton2          = 25                   { push buttons }
buton3          = 26                   { push buttons }
buton4          = 27                   { push buttons }

     
Zero_Out = 0                  {valvue to reset historic reading}

i2cSCL        = 28   
EEPROMAddr    = %1010_0000
VAR

byte h_menu                     { Hoofdmenu Variabele }
long stack1[128] ,stack2[128]   ,stack3[128]{stackspace for new cog }

long reading,  dig1,dig11,  dig2,dig22,  dig3,dig33,  dig4,dig44               { decodeer berekening waardes }
long waarde1,waarde11,  waarde2,waarde22,  waarde3,waarde33,  waarde4,waarde44 { decodeer berekening waardes }

byte templock,notactive

byte  temp[32]                               {input temp }
byte  lv[32]                                 {input lv }
long tempC,tempC1,tempC2,tempC3              {global temp vars }
long lv1,lv2,lv3                             {global lv vars }

long tempmax,tempmin       {Historis Min /Max Temp Variabelen }
long lvmax,lvmin ,eepromData          {Historis Min /Max LV Variabelen }

long Setpoint,Offset                         { aanstuur waardes }

long teller1,teller2 ,screen,punt

long numleds_, firstled_, persistence_, leds[7] 
OBJ
  shift :       "Simple_74HC595"             { lcd control object }

    sht           : "Sensirion_full"         { temp/lv sensor control object }
  fp            : "FloatString"              { Math object }
  f             : "Float32"                  { Math object }
  rom: "I2C_ROMEngine"                       { Eeprom Backup object }
    eeprom  : "Propeller Eeprom" 
  i2cObject      : "basic_i2c_driver"
    led          : "led_pwm"   
PUB main

  persistence_ := 0
  numleds_ := 7
  firstled_ := 9
  

 
  dira[buton1]~                               {make button input}                           
  dira[buton2]~                               {make button input}
  dira[buton3]~                               {make button input}
  dira[buton4]~                               {make button input}

  dira[led_1]~~                                {make Led output}
  dira[led_2]~~                                {make Led output}
  dira[led_3]~~                                {make Led output}
  dira[led_4]~~                                {make Led output}
  dira[led_5]~~                                {make Led output}
  dira[led_6]~~                                {make Led output}
  dira[led_7]~~                                {make Led output}


  cognew(tempcontrol,@stack1)               {Start temp/Lv meting in new cog}
  cognew(display_controle,@stack3)
  
  h_menu:=  1                                           {Set LCD to home menu}
    
  repeat
  
     if ina[buton3]==0                           { down right button}
        h_menu:= h_menu + 1  
        teller1 := teller2 := notactive:= 0
        if h_menu == 9                            {menu size = 8}
          h_menu := 1
        waitcnt (clkfreq /4+ cnt)
                                             
     if ina[buton4]     ==0                           {up left button }
       h_menu:=h_menu - 1
       teller1 := teller2 := notactive:= 0
       if h_menu ==0                              {menu size = 8}
          h_menu:= 8                                            
       waitcnt (clkfreq / 4+ cnt)

                  
     if h_menu > 9
        h_menu:= 0

     
     if h_menu < 1
        h_menu:= 8
     
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''         
     if ina[buton1]==0  and h_menu == 3             {Return to Start Menu from lv reading 'IF UP BUTTON PRESED'}
           waitcnt (clkfreq / 4+ cnt)
           h_menu:=  1

     if ina[buton1]==0  and h_menu == 4             {Return to Start Menu from historic max temp reading 'IF UP BUTTON PRESED'}
           waitcnt (clkfreq / 4+ cnt)
           h_menu:=  1

     if ina[buton1]==0  and h_menu == 5             {Return to Start Menu from historic min temp reading 'IF UP BUTTON PRESED'}
           waitcnt (clkfreq / 4+ cnt)
           h_menu:=  1

     if ina[buton1]==0  and h_menu == 6             {Return to Start Menu from historic max lv reading 'IF UP BUTTON PRESED'}
           waitcnt (clkfreq / 4+ cnt)
           h_menu:=  1

     if ina[buton1]==0  and h_menu == 7             {Return to Start Menu from historic min lv reading 'IF UP BUTTON PRESED'}
           waitcnt (clkfreq / 4+ cnt)
           h_menu:=  1
   '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    if ina[buton2]==0  and h_menu == 3                {'IF DOWN BUTTON PRESED'when at MAX TEMP menu }
       waitcnt (clkfreq * 2 + cnt)                    {wait 2 sec and check if still presed }
       if ina[buton2]==0  and h_menu == 3             
           waitcnt (clkfreq / 4 + cnt)
           i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6989,Zero_Out)         {RESET HISTORIC MAX TEMP }
           tempmax:=tempC3                          {SET NEW MAX TEMP HISTORIC TO CURRENT TEMP }
                                               '''''''''''''''''''''''''''''''''''''''''''
    if ina[buton2]==0  and h_menu == 4             {'IF DOWN BUTTON PRESED' when at MIN TEMP menu }
       waitcnt (clkfreq * 2 + cnt)                 {wait 2 sec and check if still presed }
        if ina[buton2]==0  and h_menu == 4
           waitcnt (clkfreq / 4 + cnt)
           i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6985,Zero_Out)         {RESET HISTORIC MIN TEMP }
           tempmin:=tempC3                          {SET NEW MIN TEMP HISTORIC TO CURRENT TEMP } 
                                               '''''''''''''''''''''''''''''''''''''''''''
    if ina[buton2]==0  and h_menu == 5             {'IF DOWN BUTTON PRESED' when at MAX LV menu }
       waitcnt (clkfreq * 2 + cnt)                  {wait 2 sec and check if still presed }
       if ina[buton2]==0  and h_menu == 5
           waitcnt (clkfreq / 4 + cnt)
           i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6997,Zero_Out)         {RESET HISTORIC MAX LV }
           lvmax:=lv3                          {SET NEW MAX LV HISTORIC TO CURRENT LV }
                                               '''''''''''''''''''''''''''''''''''''''''''
    if ina[buton2]==0  and h_menu == 6             {'IF DOWN BUTTON PRESED when at MIN LV menu '}
       waitcnt (clkfreq * 2 + cnt)                  {wait 2 sec and check if still presed }
        if ina[buton2]==0  and h_menu == 6
           waitcnt (clkfreq  / 4 + cnt)               
           i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6993,Zero_Out)         {RESET HISTORIC MIN LV }
           lvmin:=lv3                          {SET NEW MIN LV HISTORIC TO CURRENT LV } 
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    tellerchek
    
    case  h_menu
       1:
         step1
         punt:= 1
         screen:= tempc3
         teller_1
         teller_2 
                
       2:
         step2
         punt:= 0
         screen:=lv3
         punt:= 0 
         teller_1
         teller_2 
        
       3:  
         step3
         punt:= 1
         screen:=tempmax  
         teller_1
         
       4:
        step4
        punt:= 1
        screen:=tempmin
        teller_1
        
       5:  
         step5
         punt:= 0
         screen:=lvmax
         teller_1
         
       6:
        step6
        punt:= 0
        screen:=lvmin
        teller_1
        
       7:  
         step7
         instel_setpoint
         
         
       8:
        step8
        instel_Offset
        
        
  waitcnt(clkfreq + cnt)

PUB tellerchek

    if teller1 > 60000                                { return to Temp Reading if Noting Happening for 30 sec }
       teller1 := 0
       h_menu := 1
       notactive := 1
        
    if teller2 > 30000   and h_menu == 1                          { Scroll from Temp to RV% after 45 sec nothing happen}
       teller2 := 0
       h_menu := 2
        
    if teller2 > 30000   and h_menu == 2              { Scroll from RV% to Temp after 15 sec nothing happen }
       teller2 := 0
       h_menu := 1
       
PUB teller_1

  teller1:=teller1 + 1
  return
PUB teller_2
  if notactive == 1
    teller2:=teller2 + 1
  return  
PUB instel_setpoint 

       setpoint :=  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6981)
       teller1 := teller2 :=0                     
  repeat
        punt:= 0
        screen:= Setpoint
        teller_1
        teller_2
        
        if ina[buton1]==0      and setpoint < 99                     { down scroll button}
           
             Setpoint:= Setpoint + 1
           
         waitcnt (clkfreq / 4+ cnt)

        if ina[buton2]==0    and setpoint > 1                        { down scroll button}
           
             Setpoint:= Setpoint - 1
           
         waitcnt (clkfreq / 4+ cnt)
                
        if ina[buton3]==0 
          waitcnt (clkfreq / 4+ cnt)
          h_menu:=8
          teller1 := teller2 :=0  
          if setpoint ==  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6981)
            return       
          else
            i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6981, setpoint)
            return
            
        if ina[buton4]==0 
          waitcnt (clkfreq / 4+ cnt)
          h_menu:= 6
          teller1 := teller2 :=0  
          if setpoint ==  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6981)
            return       
          else
            i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6981, setpoint)
            return

          
        if teller1 > 60000                                { return to Temp Reading if Noting Happening for 30 sec }
           teller1 := 0
           notactive := 1
        
        if teller2 > 30000                               { Scroll from Temp to RV% after 45 sec nothing happen}
           teller2 := 0
           h_menu := 1

           if setpoint ==  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6981)
            return       
           else
            i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6981, setpoint)
            return
       
PUB instel_Offset 

       offset :=  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6977)
       teller1 := teller2 := 0                      
  repeat
        punt:= 0
        screen:=Offset
        teller_1
        
        if ina[buton1]==0      and offset < 10                     { down scroll button}
           
             Offset:= Offset + 1
           
         waitcnt (clkfreq / 4+ cnt)

        if ina[buton2]==0    and Offset > 1                        { down scroll button}
           
             Offset:= Offset - 1
           
         waitcnt (clkfreq / 4+ cnt)
                
        if ina[buton3]==0 
          waitcnt (clkfreq / 4+ cnt)
          h_menu:=1
          teller1 := teller2 :=0  
          if Offset ==  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6977)
            return       
          else
            i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6977, Offset)
            return
            
        if ina[buton4]==0 
          waitcnt (clkfreq / 4+ cnt)
          h_menu:= 7
          teller1 := teller2 :=0  
          if Offset ==  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6977)
            return       
          else
            i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6977, Offset)
            return


        if teller1 > 60000                                { return to Temp Reading if Noting Happening for 30 sec }
           teller1 := 0
           notactive := 1
        
        if teller2 > 30000                               { Scroll from Temp to RV% after 45 sec nothing happen}
           teller2 := 0
           h_menu := 1

           if Offset ==  i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6977)
              return       
           else
              i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6977, Offset)
              return

PUB Tempcontrol       | status 

    dira[Relay_1]~~
    templock:=locknew
  
    
    sht.start(SHT_DATA,SHT_CLK)
    f.start
    
    lvmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6997)
    lvmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6993)
    tempmax := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6989)
    tempmin := i2cObject.ReadLong(i2cSCL, EEPROMAddr, $6985)
    
  repeat 
    repeat until not lockset(templock)    
      sht.config(33,sht#off,sht#yes,sht#hires)
      tempC := celsius(f.FFloat(sht.readHumidity))
      tempC1 := F.FMul(celsius(f.FFloat(sht.readTemperature)),10.0)     {floating point raw measurement temp}
      tempC2 := fp.FloatToFormat(tempC1, 2, 0)               { string for the display}
      bytemove(@Temp, tempC2, strsize(tempC2) +1)      { copy string }
      tempC3 :=f.FTrunc(tempC1)                              { integer to calculate/use  }
      
     
      lv1 := humidity(tempC, f.FFloat(sht.readHumidity))   {floating poitn ram measurement RH }
      lv2 := fp.FloatToFormat(lv1, 2, 0)                    { string for the display}
      bytemove(@Lv, lv2, strsize(lv2) +1)            { copy string }
      lv3 :=f.FTrunc(lv1)
      lockclr(templock)
    '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''  

    if tempmin == 0                                    '' max/ min temp geheugen ''
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
           tempmin:=tempC3
                 
    if tempC3 > tempmax
        if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries" }
          tempmax := tempC3
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6989, tempC3)
           
    if tempC3 < tempmin
       if tempC3 < 999 and tempC3 > 0                   { remove faulty readings from getting stored in history "boundaries"} 
         tempmin := tempC3   
         i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6985, tempC3)

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    if lvmin == 0                                    '' max/ min lv geheugen ''
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries } 
           lvmin:=lv3
                 
    if lv3 > lvmax
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }
          lvmax := lv3                                 
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6997, lv3)
                     
    if lv3 < lvmin
       if lv3 < 99 and lv3 > 10                   { remove faulty readings from getting stored in history boundaries }  
          lvmin := lv3   
          i2cObject.WriteLong(i2cSCL, EEPROMAddr, $6993, lv3) 
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''           
    if lv3 < (setpoint - offset)
           status:=1

    if lv3 > (setpoint + offset)
        status:=0
        

    if status == 1
         outa[Relay_1]~~ 
    else
         outa[Relay_1]~


    waitcnt(clkfreq + cnt)


    

PUB display_controle

  shift.init(SR_CLOCK, SR_LATCH, SR_DATA)              {init lcd driver }
  intro
  repeat

    print(long[@screen]) 

PUB print(waarde)
                           
  incode(waarde)
  waitcnt(clkfreq/240 + cnt)
  decode(waarde)
  waitcnt(clkfreq/140 + cnt) 
PUB decode(invoer)

  waarde1 := invoer / 10
  waarde11 := waarde1 * 10
  dig1 := invoer - waarde11

  case dig1    
    0: dig11 := 1056964608
    1: dig11 := 100663296
    2: dig11 :=  1526726656
    3: dig11 :=  1325400064
    4: dig11 :=  1711276032
    5: dig11 :=  1828716544
    6: dig11 :=  2097152000
    7: dig11 :=  117440512
    8: dig11 :=  2130706432
    9: dig11 :=  1862270976
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

  waarde2 := waarde1 / 10
  waarde22 := waarde2 * 10
  dig2 := waarde1 - waarde22

  case dig2    
    0: dig22 := 4128768 
    1: dig22 := 393216  
    2: dig22 :=  5963776 
    3: dig22 :=  5177344 
    4: dig22 :=  6684672 
    5: dig22 :=  7143424 
    6: dig22 :=  8192000 
    7: dig22 :=  458752  
    8: dig22 :=  8323072 
    9: dig22 :=  7274496 

  if waarde1 == 0  and invoer > 0                        { 0004 weghalen }
     dig22 := 0 

  if waarde1 == 0  and invoer == 0                        { 0004 weghalen }
     dig22 := 0    
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

  waarde3 := waarde2 / 10
  waarde33 := waarde3 * 10
  dig3 := waarde2 - waarde33

  case dig3    
    0: dig33 := 16128
    1: dig33 := 1536
    2: dig33 :=  23296
    3: dig33 :=  20224
    4: dig33 :=  26112
    5: dig33 :=  27904
    6: dig33 :=  32000
    7: dig33 :=  1792
    8: dig33 :=  32512
    9: dig33 :=  28416

  if waarde2 == 0  and waarde1 > 0                       { 0004 weghalen }
     dig33 := 0

  if waarde2 == 0  and waarde1 == 0 
     dig33 := 0  
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 
  case waarde3    
    
    1: dig44 := 6
    2: dig44 :=  91
    3: dig44 :=  79
    4: dig44 :=  102
    5: dig44 :=  109
    6: dig44 :=  125
    7: dig44 :=  7
    8: dig44 :=  127
    9: dig44 :=  111

  if waarde3 == 0                                        { 0004 weghalen }
     dig44 := 0
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''      
  

  if punt == 1
    shift.Out( dig11 + dig22 + dig33 + dig44 + 8388608  )

  if punt == 0
     shift.Out( dig11 + dig22 + dig33 + dig44 )   
  

 
  return
PUB  incode(invoer)

  waarde1 := invoer / 10
  waarde11 := waarde1 * 10
  dig1 := invoer - waarde11

  case dig1    
    0: dig11 := 3221225472
    1: dig11 := 4177526784
    2: dig11 :=  2751463424
    3: dig11 :=  2952790016
    4: dig11 :=  2566914048
    5: dig11 :=  2449473536
    6: dig11 :=  2181038080
    7: dig11 :=  4160749568
    8: dig11 :=  2147483648
    9: dig11 :=  2415919104
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

  waarde2 := waarde1 / 10
  waarde22 := waarde2 * 10
  dig2 := waarde1 - waarde22

  case dig2    
    0: dig22 := 12581912
    1: dig22 := 16318464
    2: dig22 :=  10747904
    3: dig22 :=  11534336
    4: dig22 :=  10027008
    5: dig22 :=  9568256
    6: dig22 :=  8519680
    7: dig22 :=  16252928
    8: dig22 :=  8388608
    9: dig22 :=  9437184

  if waarde1 == 0  and invoer > 0                        { 0004 weghalen }
     dig22 := 16711680

  if waarde1 == 0  and invoer == 0                        { 0004 weghalen }
     dig22 := 16711680
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

  waarde3 := waarde2 / 10
  waarde33 := waarde3 * 10
  dig3 := waarde2 - waarde33

  case dig3    
    0: dig33 := 49152
    1: dig33 := 63744
    2: dig33 :=  41984
    3: dig33 :=  45056
    4: dig33 :=  39168
    5: dig33 :=  37376
    6: dig33 :=  33280
    7: dig33 :=  63488
    8: dig33 :=  32768
    9: dig33 :=  36864

  if waarde2 == 0  and waarde1 > 0                       { 0004 weghalen }
     dig33 := 65280

  if waarde2 == 0  and waarde1 == 0 
     dig33 := 65280  
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
 
  case waarde3    
    
    1: dig44 := 249
    2: dig44 :=  164
    3: dig44 :=  176
    4: dig44 :=  153
    5: dig44 :=  146
    6: dig44 :=  130
    7: dig44 :=  248
    8: dig44 :=  128
    9: dig44 :=  144

  if waarde3 == 0                                        { 0004 weghalen }
     dig44 := 255
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''      


  if punt == 1
     shift.Out( dig11 + dig22 + dig33 + dig44  - 8388608)   

  if punt == 0
     shift.Out( dig11 + dig22 + dig33 + dig44 )   

 
  return
    
PUB celsius(t)
  ' from SHT1x/SHT7x datasheet using value for 3.5V supply
  ' celsius = -39.7 + (0.01 * t)
  return f.FAdd(-39.7, f.FMul(0.01, t))  
  
PUB humidity(t, rhh) | rhLinear
  ' rhLinear = -2.0468 + (0.0367 * rh) + (-1.5955E-6 * rh * rh)
  ' simplifies to: rhLinear = ((-1.5955E-6 * rh) + 0.0367) * rh -2.0468
  rhLinear := f.FAdd(f.FMul(f.FAdd(0.0367, f.FMul(-1.5955E-6, rhh)), rhh), -2.0468)
  ' rhTrue = (t - 25.0) * (0.01 + 0.00008 * rawRH) + rhLinear
  return f.FAdd(f.FMul(f.FSub(t, 25.0), f.FAdd(0.01, f.FMul(0.00008, rhh))), rhLinear)

PUB step1
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 0
    leds[2] := 0
    leds[3] := 0
    leds[4] := 0
    leds[5] := 0
    leds[6] := 1
                            
PUB step2
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 0
    leds[2] := 0
    leds[3] := 0
    leds[4] := 0
    leds[5] := 1
    leds[6] := 0 
 
PUB step3
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 0
    leds[2] := 0
    leds[3] := 1
    leds[4] := 0
    leds[5] := 0
    leds[6] := 1 
 
PUB step4
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 0
    leds[2] := 1
    leds[3] := 0
    leds[4] := 0
    leds[5] := 0
    leds[6] := 1 
 
PUB step5
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 0
    leds[2] := 0
    leds[3] := 1
    leds[4] := 0
    leds[5] := 1
    leds[6] := 0 
 
PUB step6
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 0
    leds[2] := 1
    leds[3] := 0
    leds[4] := 0
    leds[5] := 1
    leds[6] := 0 

PUB step7
  
    led.start(@numleds_)
    leds[0] := 0
    leds[1] := 1
    leds[2] := 0
    leds[3] := 0
    leds[4] := 0
    leds[5] := 0
    leds[6] := 0    

PUB step8
        
    led.start(@numleds_)
    leds[0] := 1
    leds[1] := 0
    leds[2] := 0
    leds[3] := 0
    leds[4] := 0
    leds[5] := 0
    leds[6] := 0

PUB Intro

     repeat 30
       shift.Out( 1979711488)                  {  H  }
       waitcnt(clkfreq/240 + cnt)

       shift.Out(2298478592+255+16711680+65280)
       waitcnt(clkfreq/140 + cnt)
       
     repeat 30                         
       shift.Out( 7733248+1996488704)          {  HA  }
       waitcnt(clkfreq/240 + cnt)

       shift.Out(8978432+2281701376+255+65280)
       waitcnt(clkfreq/140 + cnt)

       
     repeat 30                         
       shift.Out( 30208+7798784+939524096)
       waitcnt(clkfreq/240 + cnt)              {  HAL  }

       shift.Out(35072+8912896+3338665984+255)
       waitcnt(clkfreq/140 + cnt)

    
     repeat 30                         
       shift.Out(118+30464+3670016+939524096 )
       waitcnt(clkfreq/240 + cnt)              {  HALL  }

       shift.Out(137+34816+13041664+3338665984)
       waitcnt(clkfreq/140 + cnt)

            
     repeat 30                         
       shift.Out(119+14336+3670016+1056964608 )
       waitcnt(clkfreq/240 + cnt)              {  ALLO  }

       shift.Out(136+50944+13041664+3221225472)
       waitcnt(clkfreq/140 + cnt)  

     repeat 30                         
       shift.Out(56+14336+4128768 )
       waitcnt(clkfreq/240 + cnt)              {  LLO_  }

       shift.Out(199+50944+12582912+4278190080)
       waitcnt(clkfreq/140 + cnt)

     repeat 30                         
       shift.Out( 56+16128+100663296)
       waitcnt(clkfreq/240 + cnt)              {  LO_I  }

       shift.Out(199+49152+4177526784+16711680)
       waitcnt(clkfreq/140 + cnt)

     
     repeat 30                         
       shift.Out( 63+393216+956301312)
       waitcnt(clkfreq/240 + cnt)              {  O_IC  }

       shift.Out(192+16318464+3321888768+65280)
       waitcnt(clkfreq/140 + cnt)

     repeat 30                         
       shift.Out(1536+3735552+2030043136 )
       waitcnt(clkfreq/240 + cnt)              {  _ICE  }

       shift.Out(63744+12976128+2248146944+255)
       waitcnt(clkfreq/140 + cnt)

     repeat 150                         
       shift.Out(6+14592+7929856 )
       waitcnt(clkfreq/240 + cnt)              {  ICE_  }

       shift.Out(249+50688+8781824+4278190080)
       waitcnt(clkfreq/140 + cnt)              